/*******************************************************************************
 transcode_process.h

 Copyright (C) 2016-2017 CodeShop B.V.
 http://www.code-shop.com

 For licensing see the LICENSE file
*******************************************************************************/

#ifndef TRANSCODE_PROCESS_H_AKW
#define TRANSCODE_PROCESS_H_AKW

// #include "mod_streaming_export.h"

#ifdef __cplusplus
extern "C" {
#endif

struct mp4_process_context_t;

// Entrypoint for transcoding functionality. The buckets passed as input consist
// of two ISOBMFF files. I.e. they start with a "ftyp" followed by a "moov" box.
//
// The first ISOBMFF describes the destination description.
//
// The second ISOBMFF holds the both the input description as well as the source
// samples.
//
// When an "edit" is present in the destination description, it represents the
// time interval. The timescale of the interval is in media timescale units.
//
// Note that it is important to realize that we are telling the transcoding
// the time iterval for which it must generate content. The destination
// description is leading and the source samples may overlap this interval.

MP4_DLL_EXPORT int transcode_process(struct mp4_process_context_t* context);

// Returns a fixed 0-terminated prefix for a pipeline config.
MP4_DLL_EXPORT char const *pipeline_config_prefix(void);

#ifdef __cplusplus
} /* extern C definitions */
#endif

#endif // TRANSCODE_H_AKW

// End Of File

